import asyncio

from fancy_me import logger
from fancy_me.ws import WebSocketServer
from fancy_me.udp import DataServer


class Ipo(object):
    def __init__(self, ws_host="0.0.0.0", ws_port=5400, udp_host="0.0.0.0", udp_port=5401):
        self.loop = asyncio.get_event_loop()
        self.ws_host = ws_host
        self.ws_port = ws_port
        self.udp_host = udp_host
        self.udp_port = udp_port
        self.ws_server = self.loop.create_server(WebSocketServer, ws_host, ws_port)
        self.udp_server = self.loop.create_server(DataServer, udp_host, udp_port)

    def start(self):
        self.loop.run_until_complete(self.ws_server)
        self.loop.run_until_complete(self.udp_server)
        logger.info("start successful")
        self.loop.run_forever()


if __name__ == '__main__':
    io = Ipo()
    io.start()
